/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.tables.records.VCoreGroupRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.JSON;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreGroup extends TableImpl<VCoreGroupRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_group</code>
     */
    public static final VCoreGroup V_CORE_GROUP = new VCoreGroup();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreGroupRecord> getRecordType() {
        return VCoreGroupRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_group.pk</code>.
     */
    public final TableField<VCoreGroupRecord, Integer> PK = createField(DSL.name("pk"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>common_dd.v_core_group.name</code>.
     */
    public final TableField<VCoreGroupRecord, String> NAME = createField(DSL.name("name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_group.users</code>.
     */
    public final TableField<VCoreGroupRecord, JSON> USERS = createField(DSL.name("users"), SQLDataType.JSON, this, "");

    private VCoreGroup(Name alias, Table<VCoreGroupRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreGroup(Name alias, Table<VCoreGroupRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_group" as  SELECT g.pk,
          g.name,
          json_agg(t_core_usergroup.fk_usnr) AS users
         FROM (common_dd.t_core_group g
           LEFT JOIN common_dd.t_core_usergroup ON ((t_core_usergroup.fk_group = g.pk)))
        GROUP BY g.pk, g.name;
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_group</code> table reference
     */
    public VCoreGroup(String alias) {
        this(DSL.name(alias), V_CORE_GROUP);
    }

    /**
     * Create an aliased <code>common_dd.v_core_group</code> table reference
     */
    public VCoreGroup(Name alias) {
        this(alias, V_CORE_GROUP);
    }

    /**
     * Create a <code>common_dd.v_core_group</code> table reference
     */
    public VCoreGroup() {
        this(DSL.name("v_core_group"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreGroup as(String alias) {
        return new VCoreGroup(DSL.name(alias), this);
    }

    @Override
    public VCoreGroup as(Name alias) {
        return new VCoreGroup(alias, this);
    }

    @Override
    public VCoreGroup as(Table<?> alias) {
        return new VCoreGroup(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreGroup rename(String name) {
        return new VCoreGroup(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreGroup rename(Name name) {
        return new VCoreGroup(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreGroup rename(Table<?> name) {
        return new VCoreGroup(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup where(Condition condition) {
        return new VCoreGroup(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreGroup where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreGroup where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreGroup where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreGroup where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreGroup whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
